﻿using System;
using System.Collections;
using System.Data;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;
using DFI.Common.BusinessLayerClasses;
using DFI.Common.Security;
using DFI.Common.Web;
using DFI.Common.Web.WebControls;
using DFI.Common;
using LIS.Classes;
using Infragistics.Web.UI.GridControls;


namespace LIS
{
    public partial class LIS_ApplicationDetails : PageBase
    {
        public bool bMinMaxAllowed = false;
        public bool bTargetAllowed = false;
        public bool bRowUpdated = false;
        public bool bRowAdded = false;
        protected new void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                txtRecordID.Value = Request["id"];
                SetMode("VIEWER");
                InitializeForm();
                InitializeButtons();
                PopulateForm();
                BindGrid();
                PopulateDropDownControl();
                
            }
            
            BindGrid();
            //object ctrl = Request.Params["__EVENTTARGET"];
            //if ((Request.Params.Get("__EVENTTARGET")) == "Show_the_dialog")
            //{
            //    CheckforAssignedToLegal();
            //}
           
           
        }

        #region Form Methods

        //protected void Page_PreRender(object sender, EventArgs e)
        //{
        //    if (bRowAdded || bRowUpdated)
        //    {
        //        CheckforAssignedToLegal();
        //        bRowAdded = false;
        //        bRowUpdated = false;
        //    }
        //}

        protected void InitializeForm()
        {
            /* ----------------------------------------------------------------------------------------------------------
            Initialize list boxes and set selected index to zero
            ---------------------------------------------------------------------------------------------------------- */
            LicenseeApplication la = new LicenseeApplication();
            DFILocation dl = new DFILocation();
            BCBaseClass bc = new BCBaseClass();

            ListBoxUtil.PopulateListBox(ddlApplicant, la.GetDropdownApplicants(), "ID", "PreLicenseeName", "", "", true);
            ListBoxUtil.PopulateListBox(ddlDFILocation, dl.GetDropdownDFILocation(), "ID", "Name", "", "0", true);
            ListBoxUtil.PopulateListBox(ddlInstitutionType, la.GetDropdownInstitutionTypes(), "ID", "InstitutionTypeDesc", "", "", true);
            ListBoxUtil.PopulateListBox(ddlApplicationType, la.GetDropdownApplicationTypes(), "ID", "ApplicationTypeDesc", "", "", true);
            ListBoxUtil.PopulateListBox(ddlDeputy, la.GetDropdownDeputies(), "ID", "DeputyName", "0", "0", true);
            ListBoxUtil.PopulateListBox(ddlFIM, la.GetDropdownFIMs(), "ID", "FIMName", "0", "0", true);
            ListBoxUtil.PopulateListBox(ddlAttorney, la.GetDropdownAttornies(), "ID", "AttorneyName", "0", "0", true);
            ListBoxUtil.PopulateListBox(ddlEIC, la.GetDropdownEICs(), "ID", "EICName", "0", "0", true);
            ListBoxUtil.PopulateListBox(ddlState, bc.USStates(), "Abbreviation", "Abbreviation", "", "", true);      

        }

        protected void PopulateForm()
        {
            LicenseeApplication la = new LicenseeApplication();
            txtRecordID.Value = Request["id"];

            if (txtRecordID.Value != "0")
            {
                DataRow oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                btnEdit.Enabled = true;
                txtRecordID.Value = oDataRow["ID"].ToString();
                ListBoxUtil.SetSelect(ddlApplicant, oDataRow["PreLicenseeID"].ToString());
                ListBoxUtil.SetSelect(ddlInstitutionType, oDataRow["InstitutionTypeID"].ToString());
                ListBoxUtil.SetSelect(ddlApplicationType, oDataRow["ApplicationTypeID"].ToString());
                ListBoxUtil.SetSelect(ddlDFILocation, oDataRow["LocationID"].ToString());
                ListBoxUtil.SetSelect(ddlDeputy, oDataRow["DeputyID"].ToString());
                ListBoxUtil.SetSelect(ddlFIM, oDataRow["AssistantDeputyID"].ToString());
                ListBoxUtil.SetSelect(ddlAttorney, oDataRow["AttorneyID"].ToString());
                ListBoxUtil.SetSelect(ddlEIC, oDataRow["EICID"].ToString());
                txtMinCapital.Text = oDataRow["MinCapital"].ToString();
                txtMaxCapital.Text = oDataRow["MaxCapital"].ToString();
                txtTarget.Text = oDataRow["ReferringInst"].ToString();
                txtFirstName.Text = oDataRow["FirstName"].ToString();
                txtMiddleInit.Text = oDataRow["MiddleInit"].ToString();
                txtLastName.Text = oDataRow["LastName"].ToString();
                txtAddress.Text = oDataRow["Address"].ToString();
                txtCity.Text = oDataRow["City"].ToString();
                ListBoxUtil.SetSelect(ddlState, oDataRow["State"].ToString());
                txtZipCode.Text = oDataRow["ZipCode"].ToString();
                txtEmail.Text = oDataRow["Email"].ToString();
                txtPhoneNo.Text = oDataRow["PhoneNumber"].ToString();

                CheckforTargetDate(int.Parse(txtRecordID.Value), int.Parse(ddlInstitutionType.SelectedValue), int.Parse(ddlApplicationType.SelectedValue));
                string UserName = GetUserName(oDataRow["UpdatedByID"].ToString());
                lblUpdate.Text = "Last Update: " + oDataRow["DateUpdated"].ToString() + " By: " + UserName;               

                if (int.Parse(ddlInstitutionType.SelectedValue) == 1)
                {
                     //bMinMaxAllowed = true;
                    txtMinCapital.Visible = true;
                    txtMaxCapital.Visible = true;
                    txtMinCapital.Enabled = true;
                    txtMaxCapital.Enabled = true;

                    if (int.Parse(ddlApplicationType.SelectedValue) == 50 || (int.Parse(ddlApplicationType.SelectedValue) == 9) || (int.Parse(ddlApplicationType.SelectedValue) == 11) || (int.Parse(ddlApplicationType.SelectedValue) == 102))
                     {
                         //bTargetAllowed = true;
                         txtTarget.Visible = true;
                         txtTarget.Enabled = true;
                     }                  
                }
                else if (int.Parse(ddlInstitutionType.SelectedValue) == 5)
                {
                    if (int.Parse(ddlApplicationType.SelectedValue) == 9)
                    {
                        //bTargetAllowed = true;
                        txtTarget.Visible = true;
                        txtTarget.Enabled = true;
                    }
                }
                else if (int.Parse(ddlInstitutionType.SelectedValue) == 21)
                {
                    if (int.Parse(ddlApplicationType.SelectedValue) == 9)
                    {
                        //bTargetAllowed = true;
                        txtTarget.Visible = true;
                        txtTarget.Enabled = true;
                    }
                }
                else if (int.Parse(ddlInstitutionType.SelectedValue) == 6)
                {
                    if (int.Parse(ddlApplicationType.SelectedValue) == 50)
                    {
                        //bTargetAllowed = true;
                        txtTarget.Visible = true;
                        txtTarget.Enabled = true;
                    }
                }
                else if (int.Parse(ddlInstitutionType.SelectedValue) == 4)
                {
                    if (int.Parse(ddlApplicationType.SelectedValue) == 50 || (int.Parse(ddlApplicationType.SelectedValue) == 9) || (int.Parse(ddlApplicationType.SelectedValue) == 102))
                    {
                        //bTargetAllowed = true;
                        txtTarget.Visible = true;
                        txtTarget.Enabled = true;
                    }
                }

                //CheckforAssignedToLegal();

            }
        }

        protected void ddlInstitutionType_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            int curItem1 = int.Parse(ddlInstitutionType.SelectedValue);
           
            if (curItem1 == 1)
            {
                //bMinMaxAllowed = true;
                //bTargetAllowed = true;

                //SetMode("USER");  
                txtMinCapital.Visible = true;
                txtMaxCapital.Visible = true;
                txtMinCapital.Enabled = true;
                txtMaxCapital.Enabled = true;
                txtTarget.Visible = true;
                txtTarget.Enabled = true;
                
            }
            if (curItem1 == 4)
            {
                //bTargetAllowed = true;

                //SetMode("USER");
                txtTarget.Visible = true;
                txtTarget.Enabled = true;

            }
            if (curItem1 == 5)
            {
                //bTargetAllowed = true;

                //SetMode("USER");
                txtTarget.Visible = true;
                txtTarget.Enabled = true;

            }
            if (curItem1 == 6)
            {
                //bTargetAllowed = true;

                //SetMode("USER");
                txtTarget.Visible = true;
                txtTarget.Enabled = true;

            }
            if (curItem1 == 19)
            {
                //bTargetAllowed = true;

                //SetMode("USER");
                txtTarget.Visible = true;
                txtTarget.Enabled = true;

            }
            if (curItem1 == 21)
            {
                //bTargetAllowed = true;

                //SetMode("USER");
                txtTarget.Visible = true;
                txtTarget.Enabled = true;

            }  

        }

        protected void ResetForm()
        {
            /* ----------------------------------------------------------------------------------------------------------
            Set all form values to blank/unselected
            ---------------------------------------------------------------------------------------------------------- */
            txtRecordID.Value = "0";
            txtFirstName.Text = "";
            txtMiddleInit.Text = "";
            txtLastName.Text = "";
            txtEmail.Text = "";
            txtAddress.Text = "";
            txtCity.Text = "";
            txtZipCode.Text = "";
            txtPhoneNo.Text = "";
            txtMinCapital.Text = "";
            txtMaxCapital.Text = "";
            txtTarget.Text = "";

            ListBoxUtil.SetSelect(ddlApplicant, 0);
            ListBoxUtil.SetSelect(ddlInstitutionType, 0);
            ListBoxUtil.SetSelect(ddlApplicationType, 0);
            ListBoxUtil.SetSelect(ddlDFILocation, 0);
            ListBoxUtil.SetSelect(ddlEIC, 0);
            ListBoxUtil.SetSelect(ddlFIM, 0);
            ListBoxUtil.SetSelect(ddlDeputy, 0);
            ListBoxUtil.SetSelect(ddlAttorney, 0);
            ListBoxUtil.SetSelect(ddlState, 0);        

        }

        protected void SaveForm()
        {
            Hashtable oHash = new Hashtable();
            if (txtMinCapital.Text == "")
            {
                txtMinCapital.Text = "0";
            }

            if (txtMaxCapital.Text == "")
            {
                txtMaxCapital.Text = "0";
            }

            if (lblTargetDate.Text == "") {
                lblTargetDate.Text = "1900-01-01";
                lblDaysActive.Text = "0";
                lblStatus.Text = "";
            }
            ToggleValidators(true);
            Page.Validate();

            if (Page.IsValid)
            {
                
                try
                {
                    if (txtRecordID.Value == "0")
                        new LicenseeApplication().CreateLicenseeAppDetail(int.Parse(ddlApplicant.SelectedValue)
                                                                                                     , int.Parse(ddlInstitutionType.SelectedValue)
                                                                                                     , int.Parse(ddlApplicationType.SelectedValue)
                                                                                                     , int.Parse(ddlDFILocation.SelectedValue)
                                                                                                     , int.Parse(ddlDeputy.SelectedValue)
                                                                                                     , int.Parse(ddlFIM.SelectedValue)
                                                                                                     , int.Parse(ddlAttorney.SelectedValue)
                                                                                                     , int.Parse(ddlEIC.SelectedValue)
                                                                                                     , Convert.ToDouble(txtMinCapital.Text)
                                                                                                     , Convert.ToDouble(txtMaxCapital.Text)
                                                                                                     , txtTarget.Text
                                                                                                     , txtFirstName.Text
                                                                                                     , txtMiddleInit.Text
                                                                                                     , txtLastName.Text
                                                                                                     , txtAddress.Text
                                                                                                     , txtCity.Text
                                                                                                     , (ddlState.SelectedValue)
                                                                                                     , txtZipCode.Text                                                             
                                                                                                     , txtEmail.Text
                                                                                                     , FormatPhoneNumber(txtPhoneNo.Text)
                                                                                                     , EmptyStringToDefaultDate(lblTargetDate.Text)
                                                                                                     , lblDaysActive.Text
                                                                                                     , lblStatus.Text
                                                                                                     , true
                                                                                                     , AuthenticatedUser.EmployeeID
                                                                                                     , AuthenticatedUser.EmployeeID);
                    else
                    {
                        new LicenseeApplication(int.Parse(txtRecordID.Value)).UpdateLicenseeAppDetail(int.Parse(txtRecordID.Value)
                                                                                                     , int.Parse(ddlApplicant.SelectedValue)
                                                                                                     , int.Parse(ddlInstitutionType.SelectedValue)
                                                                                                     , int.Parse(ddlApplicationType.SelectedValue)
                                                                                                     , int.Parse(ddlDFILocation.SelectedValue)
                                                                                                     , int.Parse(ddlDeputy.SelectedValue)
                                                                                                     , int.Parse(ddlFIM.SelectedValue)
                                                                                                     , int.Parse(ddlAttorney.SelectedValue)
                                                                                                     , int.Parse(ddlEIC.SelectedValue)
                                                                                                     , Convert.ToDouble(txtMinCapital.Text)
                                                                                                     , Convert.ToDouble(txtMaxCapital.Text)
                                                                                                     , txtTarget.Text
                                                                                                     , txtFirstName.Text
                                                                                                     , txtMiddleInit.Text
                                                                                                     , txtLastName.Text
                                                                                                     , txtAddress.Text
                                                                                                     , txtCity.Text
                                                                                                     , (ddlState.SelectedValue)
                                                                                                     , txtZipCode.Text
                                                                                                     , txtEmail.Text
                                                                                                     , FormatPhoneNumber(txtPhoneNo.Text)
                                                                                                     , EmptyStringToDefaultDate(lblTargetDate.Text)
                                                                                                     , lblDaysActive.Text
                                                                                                     , lblStatus.Text
                                                                                                     , true
                                                                                                     , AuthenticatedUser.EmployeeID);
                    }

                    PopulateForm();
                    hidPostBackStatus.Value = "SAVE";
                    hidPostBackMessage.Value = "Saved";


                    SetMode("VIEWER");
                    ToggleValidators(false);

                    if (txtRecordID.Value == "0")
                    {
                        btnNew.Enabled = true;
                        btnEdit.Enabled = false;
                        btnSave.Enabled = false;
                        btnCancel.Enabled = false;
                        btnSave1.Visible = false;
                    }
                    else
                    {
                        btnNew.Enabled = true;
                        btnEdit.Enabled = true;
                        btnSave.Enabled = false;
                        btnCancel.Enabled = false;
                    }

                }
                catch (Exception ex)
                {
                    hidPostBackStatus.Value = "ALERT";
                    hidPostBackMessage.Value = "ERROR : " + ex.Message;
                }
            }
        }

        public String GetUserName(string UpdatedID)
        {
            DataSet oDataSet = new DataSet();
            Hashtable oHash = new Hashtable();
            DataRow oDataRow;

            /* ----------------------------------------------------------------------------------------------------------
            Populate a particular record
            ---------------------------------------------------------------------------------------------------------- */
            oHash.Clear();
            oDataSet.Clear();
            string UserName = null;

            if (UpdatedID != "0")
            {
                oHash.Add("@ID", UpdatedID);
                oDataSet = Database.ExecuteQuery("HRMIS.usp_Employee_Select", oHash);

                oDataRow = oDataSet.Tables["data"].Rows[0];
                UserName = Convert.ToString(oDataRow["UserName"]);

            }
            return UserName;
        }

        protected void CheckforAssignedToLegal()
        {
            //LicenseeApplicationDate lad = new LicenseeApplicationDate();

            txtRecordID.Value = Request["id"];
            //bool IsRow = new LicenseeApplicationDate(int.Parse(txtRecordID.Value)).CheckDateType(int.Parse(txtRecordID.Value), 48);

            //if (IsRow == true)
            //{
            //    string myHeaderRightText = @"<img id='btnBkButton' src='/Images/Misc/ButtonClose.png' style='cursor:pointer; height:20px; width:20px;' onmouseover='this.src=""/Images/Misc/ButtonCloseOver.png""' onmouseout='this.src=""/Images/Misc/ButtonClose.png""' onclick='{0}.click();' alt='Close' />";
            //    ModalWrapperTop.WindowHeaderRightText = String.Format(myHeaderRightText, btnBackButton.ClientID);
            //    btnSend.Visible = true;
            //    btnSend.Enabled = true;
            //    ModalPopupExtender1.Show();
            //}
            DataSet oDataSet = new DataSet();
            Hashtable oHash = new Hashtable();
            DataRow oDataRow;
                        
            oHash.Clear();
            oDataSet.Clear();

            oHash.Add("@LicenseeApplicationID", int.Parse(txtRecordID.Value));
            oHash.Add("@DateTypeID", 48);
            oDataSet = Database.ExecuteQuery("LIS.usp_LicenseeApplicationDate_CheckforAssigned", oHash);

            oDataRow = oDataSet.Tables["data"].Rows[0];
            txtTo.Text = oDataRow["DeputyName"].ToString() + "; " + oDataRow["FIMName"].ToString();
            txtCc.Text = oDataRow["AttorneyName"].ToString();
            txtSubject.Text = oDataRow["PreLicenseeName"].ToString();
            txtBody.Text = "Applicant: " + oDataRow["PreLicenseeName"].ToString() + " " + "Application Type: " + oDataRow["ApplicationTypeDesc"].ToString() + " " + oDataRow["Comments"].ToString();

            string myHeaderRightText = @"<img id='btnBkButton' src='/Images/Misc/ButtonClose.png' style='cursor:pointer; height:20px; width:20px;' onmouseover='this.src=""/Images/Misc/ButtonCloseOver.png""' onmouseout='this.src=""/Images/Misc/ButtonClose.png""' onclick='{0}.click();' alt='Close' />";
            ModalWrapperTop.WindowHeaderRightText = String.Format(myHeaderRightText, btnBackButton.ClientID);
            btnSend.Visible = true;
            btnSend.Enabled = true;
            ModalPopupExtender1.Show();

            //if (UpdatedID != "0")
            //{
            //    oHash.Add("@ID", UpdatedID);
            //    oDataSet = Database.ExecuteQuery("HRMIS.usp_Employee_Select", oHash);

            //    oDataRow = oDataSet.Tables["data"].Rows[0];
            //    UserName = Convert.ToString(oDataRow["UserName"]);

            //}

        }
                
        protected void CheckforTargetDate(int LicenseeAppID, int InstitutionType, int ApplicationType)
        {
            LicenseeApplication la = new LicenseeApplication();
            DataRow oDataRow;
            txtRecordID.Value = Request["id"];

            switch (InstitutionType)
            {
                case 1:
                    switch (ApplicationType)
                    {
                        case 9:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 60);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 11:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 90);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 87:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 90);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 103:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 60);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 112:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 30);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        default:
                            this.pnlTargetInfo.Visible = false;
                            base.EmptyStringToDefaultDate(lblTargetDate.Text);
                            lblDaysActive.Text = "0";
                            lblStatus.Text = "";
                            break;
                    }
                    break;
                case 4:
                    switch (ApplicationType)
                    {
                        case 9:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 60);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 87:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 90);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 11:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 90);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 112:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 30);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        default:
                            this.pnlTargetInfo.Visible = false;
                            base.EmptyStringToDefaultDate(lblTargetDate.Text);
                            base.DBNullToZero(lblDaysActive.Text);
                            lblStatus.Text = "";
                            break;
                    }
                    break;
                case 6:
                    switch (ApplicationType)
                    {
                        case 50:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 60);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 82:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 60);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 112:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 30);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        default:
                            this.pnlTargetInfo.Visible = false;
                            base.EmptyStringToDefaultDate(lblTargetDate.Text);
                            lblDaysActive.Text = "0";
                            lblStatus.Text = "";
                            break;
                    }
                    break;
                case 21:
                    switch (ApplicationType)
                    {
                        case 9:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 120);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        case 11:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 120);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        default:
                            this.pnlTargetInfo.Visible = false;
                            base.EmptyStringToDefaultDate(lblTargetDate.Text);
                            lblDaysActive.Text = "0";
                            lblStatus.Text = "";
                            break;
                    }
                    break;
                case 24:                                                                   
                    switch (ApplicationType)
                    {
                        case 112:
                            this.pnlTargetInfo.Visible = true;
                            new LicenseeApplication(int.Parse(txtRecordID.Value)).CalculatePerformance(int.Parse(txtRecordID.Value), 30);
                            oDataRow = new LicenseeApplication(int.Parse(txtRecordID.Value)).RawData.Rows[0];
                            lblTargetDate.Text = string.Format("{0:d}", oDataRow["TargetDate"]);
                            lblDaysActive.Text = oDataRow["DaysActive"].ToString();
                            lblStatus.Text = oDataRow["Status"].ToString();
                            break;
                        default:
                            this.pnlTargetInfo.Visible = false;
                            base.EmptyStringToDefaultDate(lblTargetDate.Text);
                            lblDaysActive.Text = "0";
                            lblStatus.Text = "";
                            break;
                    }
                    break;
                default:
                    this.pnlTargetInfo.Visible = false;
                    base.EmptyStringToDefaultDate(lblTargetDate.Text);
                    lblDaysActive.Text = "0";
                    lblStatus.Text = "";
                    break;

            }
        }
       
        #endregion

        #region Mode & Validation Methods

        protected void SetMode(string sMode)
        {
            /* ----------------------------------------------------------------------------------------------------------
            Enable or disable form elements
            ---------------------------------------------------------------------------------------------------------- */           

            txtFirstName.ReadOnly = sMode == "VIEWER" ? true : false;
            txtMiddleInit.ReadOnly = sMode == "VIEWER" ? true : false;
            txtLastName.ReadOnly = sMode == "VIEWER" ? true : false;
            txtCity.ReadOnly = sMode == "VIEWER" ? true : false;
            txtZipCode.ReadOnly = sMode == "VIEWER" ? true : false;
            txtPhoneNo.ReadOnly = sMode == "VIEWER" ? true : false;
            txtEmail.ReadOnly = sMode == "VIEWER" ? true : false;
            txtAddress.ReadOnly = sMode == "VIEWER" ? true : false;
            txtCity.ReadOnly = sMode == "VIEWER" ? true : false;
            txtMinCapital.ReadOnly = sMode == "VIEWER" ? true : false;
            txtMaxCapital.ReadOnly = sMode == "VIEWER" ? true : false;
            txtTarget.ReadOnly = sMode == "VIEWER" ? true : false;     

            ddlApplicant.ReadOnly = sMode == "VIEWER" ? true : false;
            ddlInstitutionType.ReadOnly = sMode == "VIEWER" ? true : false;
            ddlApplicationType.ReadOnly = sMode == "VIEWER" ? true : false;
            ddlDFILocation.ReadOnly = sMode == "VIEWER" ? true : false;
            ddlEIC.ReadOnly = sMode == "VIEWER" ? true : false;
            ddlFIM.ReadOnly = sMode == "VIEWER" ? true : false;
            ddlDeputy.ReadOnly = sMode == "VIEWER" ? true : false;
            ddlAttorney.ReadOnly = sMode == "VIEWER" ? true : false;
            ddlState.ReadOnly = sMode == "VIEWER" ? true : false;
            
            /* ----------------------------------------------------------------------------------------------------------
            hide/unhide form elements
            ---------------------------------------------------------------------------------------------------------- */
            imgApplicationNameAsterisk.Visible = sMode == "VIEWER" ? false : true;
            imgInstTypeAsterisk.Visible = sMode == "VIEWER" ? false : true;
            imgAppTypeAsterisk.Visible = sMode == "VIEWER" ? false : true;
            imgFIMAsterisk.Visible = sMode == "VIEWER" ? false : true;            

            bMinMaxAllowed = false;
            bTargetAllowed = false;
        }

        protected void ToggleValidators(Boolean bValue)
        {
            /* ----------------------------------------------------------------------------------------------------------
            Enable or disable validators. This is necessary when using MS AJAX.
            ---------------------------------------------------------------------------------------------------------- */

            cvApplicant.Enabled = bValue;
            cvInstitutionType.Enabled = bValue;
            cvApplicationType.Enabled = bValue;
            cvFIM.Enabled = bValue;
            cvDeputy.Enabled = bValue;
            cvPhoneNumber.Enabled = bValue;
        }

        #endregion

        #region Button/Non-Grid Control Events

        protected void InitializeButtons()
        {
            /* ----------------------------------------------------------------------------------------------------------
            Initialize state of buttons
            ---------------------------------------------------------------------------------------------------------- */
            if (Authorization.isAuthorized("LIS_Administrator"))
            {
                btnNew.Visible = true;
                btnEdit.Visible = true;
                btnSave.Visible = true;
                btnCancel.Visible = true;

                btnNew.Enabled = true;

                if (txtRecordID.Value == "0")
                {
                    btnEdit.Enabled = false;
                }
                else
                {
                    btnEdit.Enabled = true;
                    btnNew.Enabled = false;
                }
            }
            else
            {
                btnNew.Enabled = false;
                btnEdit.Enabled = false;
                btnNew.Visible = false;
                btnEdit.Visible = false;
                btnSave.Visible = false;
                btnCancel.Visible = false;
            }

            btnSave.Enabled = false;
            btnCancel.Enabled = false;
        }

        /* -------------------------------------------------------------------------------------------------------------------
         Event Handlers
        ------------------------------------------------------------------------------------------------------------------- */
        protected void btnNew_Click(object sender, EventArgs e)
        {
            ResetForm();
            SetMode("USER");

            ToggleValidators(false);

            btnNew.Enabled = false;
            btnEdit.Enabled = false;
            btnSave.Enabled = true;
            btnCancel.Enabled = true;
            
            hidPostBackStatus.Value = "NEW";
            hidPostBackMessage.Value = "New Application";

           
            ToggleValidators(true);
        }

        protected void btnEdit_Click(object sender, EventArgs e)
        {
            PopulateForm();
            SetMode("USER");
            ToggleValidators(false);
            

            btnNew.Enabled = false;
            btnEdit.Enabled = false;
            btnSave.Enabled = true;
            btnCancel.Enabled = true;
            btnSave1.Visible = true;
            btnSave1.Enabled = true;
            hidPostBackStatus.Value = "EDIT";
            hidPostBackMessage.Value = "Editing Form";

            ToggleValidators(true);
        }

        protected void btnSave_Click(object sender, EventArgs e)
        {
            SaveForm();
            
        }

        protected void btnSave1_Click(object sender, EventArgs e)
        {
            
        }       

        protected void btnSend_Click(object sender, EventArgs e)
        {
            DFIMailMessage oMail = new DFIMailMessage();
            Hashtable oHash = new Hashtable();
            DataSet oDataSet = new DataSet();
            //DataRow oDataRow;

            //int intStartIndex = 0;
            //string strURL;

            ////Build hyperlink for body of email, enable ease of access directly with a single click
            //strURL = Request.Url.ToString();
            //intStartIndex = strURL.IndexOf("=");
            //if (intStartIndex > 0)
            //{    //existing record query string ID exits in the URL
            //    strURL = strURL.Remove(intStartIndex, strURL.Length - intStartIndex);
            //    strURL = strURL + "=" + txtRecordID.Value.ToString();
            //}
            //else
            //{ //new record URL has not query string of this record
            //    strURL = strURL + "=" + txtRecordID.Value.ToString();

            //}

            //oHash.Add("@EmployeeID", Convert.ToInt32(ddlContact1.SelectedValue.ToString()));
            //oDataSet = Database.ExecuteQuery("PTS.usp_GetSupEmployeeInfoByEmployeeID", oHash);
            //oDataRow = oDataSet.Tables["data"].Rows[0];

            oMail.AddAddress(txtTo.Text.ToString(), "to");
            oMail.AddAddress(AuthenticatedUser.EmailAddress.ToString(), "from");
            oMail.AddAddress(txtCc.Text.ToString(), "cc");
            oMail.MailSubject = txtSubject.Text.ToString();
            oMail.MessageBody = "The following matter has been assigned to the above lawyer ";
            oMail.MessageBody = oMail.MessageBody + txtBody.Text.ToString();
            oMail.MessageImportance = "High";
            oMail.Send();

        }

        protected void btnCancel_Click(object sender, EventArgs e)
        {
            SetMode("VIEWER");
            ToggleValidators(false);

            if (txtRecordID.Value == "0")
            {
                btnNew.Enabled = true;
                btnEdit.Enabled = false;
                btnSave.Enabled = false;
                btnCancel.Enabled = false;
                                

                ResetForm();
            }
            else
            {
                PopulateForm();
                btnNew.Enabled = true;
                btnEdit.Enabled = true;
                btnSave.Enabled = false;
                btnCancel.Enabled = false;
            }

            hidPostBackStatus.Value = "CANCEL";
            hidPostBackMessage.Value = "Cancelled";
        }

        #endregion

        #region GridView & Repeater Methods/Events

        protected void BindGrid()
        {
            Hashtable oHash = new Hashtable();
            DataTable dt = new DataTable();

            oHash.Add("@ID", int.Parse(txtRecordID.Value));

            dt = new DFI.Common.BusinessLayerClasses.LicenseeApplicationDateCollection(oHash).RawData;

            grdDateProcess.DataSource = dt;
            grdDateProcess.DataBind();
            rcwSearchResults.Count = dt.Rows.Count;
            rcwSearchResults.ShowExcelExportButton = false;
            rcwSearchResults.ShowPDFExportButton = false;
            rcwSearchResults.UpdateRecordCount();

        }

        protected void PopulateDropDownControl()
        {       

            LicenseeApplicationDate lad = new LicenseeApplicationDate();
            Infragistics.Web.UI.ListControls.WebDropDown ddlDateType = grdDateProcess.FindControl("ddlDateType") as Infragistics.Web.UI.ListControls.WebDropDown;
            
            ddlDateType.DataSource = lad.GetDropdownDateTypes();
            ddlDateType.DataBind();
            ddlDateType.Items.Insert(0, new Infragistics.Web.UI.ListControls.DropDownItem("0", "ID"));         

        }

       
        protected void grdDateProcess_RowAdding(object sender, Infragistics.Web.UI.GridControls.RowAddingEventArgs e)
        {
            LicenseeApplication la = new LicenseeApplication();
            LicenseeApplicationDate lad = new LicenseeApplicationDate();
            Infragistics.Web.UI.ListControls.WebDropDown ddlDateType = grdDateProcess.FindControl("ddlDateType") as Infragistics.Web.UI.ListControls.WebDropDown;
           
                        
            new LicenseeApplicationDate(int.Parse(txtRecordID.Value)).CreateLicenseeAppDate(int.Parse(txtRecordID.Value)
                                                                                       , int.Parse(ddlDateType.SelectedValue)
                                                                                       , Convert.ToDateTime(e.Values["ApplicationDate"])
                                                                                       , Convert.ToString(e.Values["Comments"])
                                                                                       , true
                                                                                       , AuthenticatedUser.EmployeeID
                                                                                       , AuthenticatedUser.EmployeeID);
            
            BindGrid();
            new LicenseeApplication(int.Parse(txtRecordID.Value)).UpdateCompleted(int.Parse(txtRecordID.Value));
            //CheckforAssignedToLegal();
            

        }

        protected void grdDateProcess_RowAdded(object sender, Infragistics.Web.UI.GridControls.RowAddedEventArgs e)
        {
            bRowAdded = true;
            if (e.Exception != null) { e.ExceptionHandled = true; grdDateProcess.CustomAJAXResponse.Message = e.Exception.InnerException.Message; }
            
        }

        protected void grdDateProcess_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
        {
            
            LicenseeApplicationDate lad = new LicenseeApplicationDate();
            Infragistics.Web.UI.ListControls.WebDropDown ddlDateType = grdDateProcess.FindControl("ddlDateType") as Infragistics.Web.UI.ListControls.WebDropDown;
            txtRecordID.Value = Request["id"];
            new LicenseeApplicationDate(Convert.ToInt32(e.Values["ID"])).UpdateLicenseeAppDate(Convert.ToInt32(e.Values["ID"])
                                                                                       , int.Parse(txtRecordID.Value)
                                                                                       , int.Parse(ddlDateType.SelectedValue)
                                                                                       , Convert.ToDateTime(e.Values["ApplicationDate"])
                                                                                       , Convert.ToString(e.Values["Comments"])
                                                                                       , true
                                                                                       , AuthenticatedUser.EmployeeID);
            BindGrid();
            new LicenseeApplication(int.Parse(txtRecordID.Value)).UpdateCompleted(int.Parse(txtRecordID.Value));
            bRowUpdated = true;
            e.Cancel = true;
            
            
        }

        protected void grdDateProcess_RowUpdated(object sender, Infragistics.Web.UI.GridControls.RowUpdatedEventArgs e)
        {

            if (e.Exception != null) { e.ExceptionHandled = true; grdDateProcess.CustomAJAXResponse.Message = e.Exception.InnerException.Message; }

        }
        #endregion
    }
}
